/**
 * libmecab.dll dynamic loader
 *
 * $Id: mecabdll.cpp 1 2007-11-04 17:38:04Z naoh $
 */

#include "stdafx.h"
#include "mecabdll.h"

//#include <windows.h>
#include <malloc.h>

#ifdef __cplusplus
extern "C" {
#endif

TMeCabDLLFunctions *MeCabDLL_load(const char *path)
{
	TMeCabDLLFunctions *f;

	if((f = (TMeCabDLLFunctions *)malloc(sizeof(TMeCabDLLFunctions))) == NULL)
	{
		return NULL;
	}

	if((f->hInst = LoadLibrary(path)) == NULL)
	{
		free(f);
		return NULL;
	}

	f->mecab_new = (Tmecab_new)GetProcAddress(f->hInst,
		"mecab_new");
	f->mecab_destroy = (Tmecab_destroy)GetProcAddress(f->hInst,
		"mecab_destroy");
	f->mecab_sparse_tostr = (Tmecab_sparse_tostr)GetProcAddress(f->hInst,
		"mecab_sparse_tostr");
	f->mecab_sparse_tonode = (Tmecab_sparse_tonode)GetProcAddress(f->hInst,
		"mecab_sparse_tonode");
	f->mecab_strerror = (Tmecab_strerror)GetProcAddress(f->hInst,
		"mecab_strerror");
	f->mecab_version = (Tmecab_version)GetProcAddress(f->hInst,
		"mecab_version");

	if(f->mecab_new == NULL||
	   f->mecab_destroy == NULL ||
	   f->mecab_sparse_tostr == NULL ||
	   f->mecab_sparse_tonode == NULL ||
	   f->mecab_strerror == NULL ||
	   f->mecab_version == NULL)
	{
		free(f);
		return NULL;
	}

	return f;
}

int MeCabDLL_unload(TMeCabDLLFunctions *f)
{
	if(f)
	{
		if(f->hInst)
		{
			if(!FreeLibrary(f->hInst))
			{
				return 0;
			}
		}

		free(f);
	}

	return 1;
}


#ifdef __cplusplus
} /* extern "C" */
#endif
