/* $Id: mecabdll.h 1 2007-11-04 17:38:04Z naoh $ */

#ifndef __MECABDLL_H__
#define __MECABDLL_H__

#include <windows.h>
#include <mecab.h>

extern "C" {

typedef mecab_t *(__cdecl *Tmecab_new)(int argc, char **argv);
typedef void (__cdecl *Tmecab_destroy)(mecab_t *m);
typedef const char *(__cdecl *Tmecab_sparse_tostr)(mecab_t *m, const char *str);
typedef mecab_node_t *(__cdecl *Tmecab_sparse_tonode)(mecab_t *m, const char *str);
typedef const char *(__cdecl *Tmecab_strerror)(mecab_t* m);
typedef const char *(__cdecl *Tmecab_version)();


struct TMeCabDLLFunctions {
	HINSTANCE				hInst;

	Tmecab_new				mecab_new;
	Tmecab_destroy			mecab_destroy;
	Tmecab_sparse_tostr		mecab_sparse_tostr;
	Tmecab_sparse_tonode	mecab_sparse_tonode;
	Tmecab_strerror			mecab_strerror;
	Tmecab_version			mecab_version;
};


TMeCabDLLFunctions *MeCabDLL_load(const char *path);
int MeCabDLL_unload(TMeCabDLLFunctions *f);


} /* extern "C" */
#endif /* __MECABDLL_H__ */
